<?php

class MnglBoardsHelper
{
  function &get_stored_object()
  { 
    static $this_object;

    if( !isset($this_object) or 
        empty($this_object) or
        !is_object(&$this_object) )
      $this_object =& new MnglBoardsHelper();
    
    return $this_object;
  }

  function display_message($message_class, $message, $autoembed_media=true)
  {
    $hidden = '';

    $formatted_message = MnglBoardsHelper::format_message($message, false, $autoembed_media);

    if(strlen($message) >= 255)
    {
      $hidden = ' class="mngl-hidden"';
      $teaser = MnglBoardsHelper::format_message((mb_substr($message,0,255) . "..."), false, false);
      $class_suffix = '-fake';
      
      $teaser_class = $message_class . $class_suffix;
      
      ?><span id="<?php echo $teaser_class; ?>"><?php echo $teaser; ?> <a href="javascript:mngl_toggle_two_ids('#<?php echo $message_class; ?>','#<?php echo $teaser_class; ?>')"><?php _e('Read More', 'mingle'); ?></a></span><?php
    }
    ?><span id="<?php echo $message_class; ?>"<?php echo $hidden; ?>><?php echo $formatted_message; ?></span><?php
  }
  
  function format_message($message, $strip_newlines=false, $autoembed_media=true)
  {
    global $wp_smiliessearch, $wpsmiliestrans;

    $message = stripslashes($message);

    if($strip_newlines)
      $message = preg_replace("#\n#"," ",$message);
    else
      $message = preg_replace("#\n#","<br/>",$message);
    
    $message = wptexturize($message);
    
    /* Okay -- so this works -- but I've gotta think through if this is how I want embedding to happen
    if($autoembed_media)
      $message = MnglBoardsHelper::autoembed_media($message);
    */
    
    $message = MnglBoardsHelper::style_text($message);
    $message = convert_smilies($message);
    $message = make_clickable($message);
    $message = MnglBoardsHelper::make_tags_clickable($message);
    
    return $message;
  }

  function style_text($message)
  {
    $message = preg_replace('#\*(.+?)?\*#','<b>$1</b>',$message); 
    $message = preg_replace('#-(.+?)-#','<s>$1</s>',$message); 
    $message = preg_replace('#_(.+?)_#','<em>$1</em>',$message); 
    return $message;
  }

  function autoembed_media($message)
  {
    $mngl_boards_helper =& MnglBoardsHelper::get_stored_object();
    return preg_replace_callback( '#(https?://[^\s"]+)#im', array(&$mngl_boards_helper, 'autoembed_media_callback'), $message, 1 );
  }
  
  function autoembed_media_callback($match)
  {
    global $wp_embed;
    $return = $wp_embed->shortcode( array( 'width' => 350 ), $match[1] );
    return "\n$return\n";
  }

  function board_post_url($board_post_id)
  {
    global $mngl_options;

    if(isset($mngl_options->profile_page_id) and $mngl_options->profile_page_id != 0)
    {
      $permalink = get_permalink($mngl_options->profile_page_id);
      $param_char = ((preg_match("#\?#",$permalink))?'&':'?');
      return "{$permalink}{$param_char}mbpost={$board_post_id}";
    }

    return '';
  }
  
  function &get_tagged_users($message)
  {
    global $mngl_options;
    preg_match_all('#@([a-zA-Z0-9_\-\.]+)#', $message, $matches);
    
    $users = array();

    if(is_array($matches[1]))
    {
      foreach($matches[1] as $index => $username)
      {  
        require_once(ABSPATH . WPINC . '/registration.php');

        if($user_id = username_exists($username) and !in_array($user_id,$mngl_options->invisible_users))
          $users[] =& MnglUser::get_stored_profile_by_screenname($username);
      }
    }

    return $users;
  }
  
  function make_tags_clickable($message)
  {
    $users =& MnglBoardsHelper::get_tagged_users($message);
  
    if($users and is_array($users))
    {
      foreach($users as $user)
      {
        $preg_string = "#@({$user->screenname})#";
        $preg_link   = '@<a href="' . $user->get_profile_url() . '">$1</a>';
        $message     = preg_replace( $preg_string, $preg_link, $message );
      }
    }
    return $message;
  }
}
?>
